Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/IOM/iom.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/IOM/iom.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/IOM/iom.F90	(revision 14644)
@@ -36,5 +36,5 @@
    USE phycst          ! physical constants
    USE dianam          ! build name of file
-#if defined key_iomput
+#if defined key_xios
    USE xios
 # endif
@@ -52,5 +52,5 @@
    PUBLIC   !   must be public to be able to access iom_def through iom
 
-#if defined key_iomput
+#if defined key_xios
    LOGICAL, PUBLIC, PARAMETER ::   lk_iomput = .TRUE.        !: iom_put flag
 #else
@@ -69,5 +69,5 @@
    PRIVATE iom_p1d_sp, iom_p2d_sp, iom_p3d_sp, iom_p4d_sp
    PRIVATE iom_p1d_dp, iom_p2d_dp, iom_p3d_dp, iom_p4d_dp
-#if defined key_iomput
+#if defined key_xios
    PRIVATE iom_set_domain_attr, iom_set_axis_attr, iom_set_field_attr, iom_set_file_attr, iom_get_file_attr, iom_set_grid_attr
    PRIVATE set_grid, set_grid_bounds, set_scalar, set_xmlatt, set_mooring, iom_sdate
@@ -116,5 +116,5 @@
       INTEGER         , OPTIONAL, INTENT(in)  :: kdid
       LOGICAL         , OPTIONAL, INTENT(in)  :: ld_closedef
-#if defined key_iomput
+#if defined key_xios
       !
       TYPE(xios_duration) :: dtime    = xios_duration(0, 0, 0, 0, 0, 0)
@@ -144,8 +144,10 @@
 
       llrstr = (cdname == cr_ocerst_cxt) .OR. (cdname == cr_icerst_cxt)
+      llrstr = llrstr .OR. (cdname == cr_ablrst_cxt)
       llrstr = llrstr .OR. (cdname == cr_toprst_cxt)
       llrstr = llrstr .OR. (cdname == cr_sedrst_cxt)
 
       llrstw = (cdname == cw_ocerst_cxt) .OR. (cdname == cw_icerst_cxt)
+      llrstw = llrstw .OR. (cdname == cw_ablrst_cxt)
       llrstw = llrstw .OR. (cdname == cw_toprst_cxt)
       llrstw = llrstw .OR. (cdname == cw_sedrst_cxt)
@@ -309,5 +311,5 @@
       !!----------------------------------------------------------------------
       CHARACTER(len=*), OPTIONAL, INTENT(IN) :: cdname
-#if defined key_iomput
+#if defined key_xios
       LOGICAL :: llrstw
 
@@ -316,4 +318,5 @@
          llrstw = (cdname == cw_ocerst_cxt)
          llrstw = llrstw .OR. (cdname == cw_icerst_cxt)
+         llrstw = llrstw .OR. (cdname == cw_ablrst_cxt)
          llrstw = llrstw .OR. (cdname == cw_toprst_cxt)
          llrstw = llrstw .OR. (cdname == cw_sedrst_cxt)
@@ -344,5 +347,5 @@
       INTEGER, INTENT(IN) :: idnum
 
-#if defined key_iomput
+#if defined key_xios
       INTEGER                                    :: ndims, nvars, natts, unlimitedDimId, dimlen, xtype,mdims
       TYPE(xios_field)                           :: field_hdl
@@ -358,5 +361,5 @@
       LOGICAL                                    :: lmeta
 !metadata in restart file for restart read with XIOS
-      INTEGER, PARAMETER                         :: NMETA = 10
+      INTEGER, PARAMETER                         :: NMETA = 11
       CHARACTER(LEN=lc)                          :: meta(NMETA)
 
@@ -372,4 +375,5 @@
       meta(9) = "y"
       meta(10) = "numcat"
+      meta(11) = "nav_hgt"
 
       clinfo = '          iom_set_vars_active, file: '//TRIM(iom_file(idnum)%name)
@@ -450,5 +454,5 @@
       !!---------------------------------------------------------------------
       CHARACTER(len=*) :: cdrst_file
-#if defined key_iomput
+#if defined key_xios
       TYPE(xios_file) :: file_hdl
       TYPE(xios_filegroup) :: filegroup_hdl
@@ -489,5 +493,5 @@
       REAL(dp), OPTIONAL, INTENT(IN), DIMENSION(:, :, :) :: rd3
       REAL(sp), OPTIONAL, INTENT(IN), DIMENSION(:, :, :) :: rs3
-#if defined key_iomput
+#if defined key_xios
       TYPE(xios_field) :: field_hdl
       TYPE(xios_file) :: file_hdl
@@ -549,4 +553,6 @@
       IF(idlev == jpk) THEN
          axis_ref="nav_lev"
+      ELSEIF(idlev == jpka) THEN
+         axis_ref="nav_hgt"
 #if defined key_si3
       ELSEIF(idlev == jpl) THEN
@@ -594,5 +600,5 @@
       LOGICAL, INTENT(IN)               :: ld_rstr
       INTEGER :: ji
-#if defined key_iomput
+#if defined key_xios
       TYPE(xios_domaingroup)            :: domaingroup_hdl
       TYPE(xios_domain)                 :: domain_hdl
@@ -616,4 +622,6 @@
       CALL iom_set_axis_attr( "numcat", (/ (REAL(ji,wp), ji=1,jpl) /) )
 #endif
+      CALL xios_add_child(axisgroup_hdl, axis_hdl, "nav_hgt")
+      CALL iom_set_axis_attr( "nav_hgt", (/ (REAL(ji,wp), ji=1,jpka) /) )
       CALL xios_get_handle("scalar_definition", scalargroup_hdl)
       CALL xios_add_child(scalargroup_hdl, scalar_hdl, "grid_scalar")
@@ -639,4 +647,6 @@
          ELSEIF(kdid == numrir) THEN
             cdcont = cr_icerst_cxt
+         ELSEIF(kdid == numrar) THEN
+            cdcont = cr_ablrst_cxt
          ELSEIF(kdid == numrtr) THEN
             cdcont = cr_toprst_cxt
@@ -651,4 +661,6 @@
          ELSEIF(kdid == numriw) THEN
             cdcont = cw_icerst_cxt
+         ELSEIF(kdid == numraw) THEN
+            cdcont = cw_ablrst_cxt
          ELSEIF(kdid == numrtw) THEN
             cdcont = cw_toprst_cxt
@@ -667,5 +679,5 @@
       !!---------------------------------------------------------------------
       CHARACTER(len=*), INTENT(in) :: cdname
-#if defined key_iomput
+#if defined key_xios
       TYPE(xios_context) :: nemo_hdl
       IF( TRIM(Agrif_CFixed()) == '0' ) THEN
@@ -956,5 +968,5 @@
          ENDIF
       ELSE
-#if defined key_iomput
+#if defined key_xios
          IF(lwp) WRITE(numout,*) 'XIOS RST READ (0D): ', trim(cdvar)
          CALL iom_swap(context)
@@ -1004,5 +1016,5 @@
          ENDIF
       ELSE
-#if defined key_iomput
+#if defined key_xios
          IF(lwp) WRITE(numout,*) 'XIOS RST READ (0D): ', trim(cdvar)
          CALL iom_swap(context)
@@ -1368,5 +1380,5 @@
          !
       ELSE        ! read using XIOS. Only if KEY_IOMPUT is defined
-#if defined key_iomput
+#if defined key_xios
 !would be good to be able to check which context is active and swap only if current is not restart
          idvar = iom_varid( kiomid, cdvar )
@@ -1423,5 +1435,5 @@
       CHARACTER(LEN=*), INTENT(in ) ::   cdname
       REAL(wp), DIMENSION(jpi,jpj) ::   z2d
-#if defined key_iomput
+#if defined key_xios
       IF( xios_field_is_active( cdname, at_current_timestep_arg = .TRUE. ) ) THEN
          z2d(:,:) = 0._wp
@@ -1606,5 +1618,5 @@
 
       IF( llx ) THEN
-#ifdef key_iomput
+#ifdef key_xios
          IF( kt == kwrite ) THEN
             IF(lwp) write(numout,*) 'RESTART: write (XIOS 0D) ',trim(cdvar)
@@ -1646,5 +1658,5 @@
 
       IF( llx ) THEN
-#ifdef key_iomput
+#ifdef key_xios
          IF( kt == kwrite ) THEN
             IF(lwp) write(numout,*) 'RESTART: write (XIOS 0D) ',trim(cdvar)
@@ -1687,5 +1699,5 @@
 
       IF( llx ) THEN
-#ifdef key_iomput
+#ifdef key_xios
          IF( kt == kwrite ) THEN
             IF(lwp) write(numout,*) 'RESTART: write (XIOS 1D) ',trim(cdvar)
@@ -1727,5 +1739,5 @@
 
       IF( llx ) THEN
-#ifdef key_iomput
+#ifdef key_xios
          IF( kt == kwrite ) THEN
             IF(lwp) write(numout,*) 'RESTART: write (XIOS 1D) ',trim(cdvar)
@@ -1768,5 +1780,5 @@
 
       IF( llx ) THEN
-#ifdef key_iomput
+#ifdef key_xios
          IF( kt == kwrite ) THEN
             IF(lwp) write(numout,*) 'RESTART: write (XIOS 2D) ',trim(cdvar)
@@ -1808,5 +1820,5 @@
 
       IF( llx ) THEN
-#ifdef key_iomput
+#ifdef key_xios
          IF( kt == kwrite ) THEN
             IF(lwp) write(numout,*) 'RESTART: write (XIOS 2D) ',trim(cdvar)
@@ -1849,5 +1861,5 @@
 
       IF( llx ) THEN
-#ifdef key_iomput
+#ifdef key_xios
          IF( kt == kwrite ) THEN
             IF(lwp) write(numout,*) 'RESTART: write (XIOS 3D) ',trim(cdvar)
@@ -1889,5 +1901,5 @@
 
       IF( llx ) THEN
-#ifdef key_iomput
+#ifdef key_xios
          IF( kt == kwrite ) THEN
             IF(lwp) write(numout,*) 'RESTART: write (XIOS 3D) ',trim(cdvar)
@@ -1967,5 +1979,5 @@
       REAL(sp)        , INTENT(in) ::   pfield0d
       !!      REAL(wp)        , DIMENSION(jpi,jpj) ::   zz     ! masson
-#if defined key_iomput
+#if defined key_xios
 !!clem      zz(:,:)=pfield0d
 !!clem      CALL xios_send_field(cdname, zz)
@@ -1980,5 +1992,5 @@
       REAL(dp)        , INTENT(in) ::   pfield0d
 !!      REAL(wp)        , DIMENSION(jpi,jpj) ::   zz     ! masson
-#if defined key_iomput
+#if defined key_xios
 !!clem      zz(:,:)=pfield0d
 !!clem      CALL xios_send_field(cdname, zz)
@@ -1993,5 +2005,5 @@
       CHARACTER(LEN=*)          , INTENT(in) ::   cdname
       REAL(sp),     DIMENSION(:), INTENT(in) ::   pfield1d
-#if defined key_iomput
+#if defined key_xios
       CALL xios_send_field( cdname, RESHAPE( (/pfield1d/), (/1,1,SIZE(pfield1d)/) ) )
 #else
@@ -2003,5 +2015,5 @@
       CHARACTER(LEN=*)          , INTENT(in) ::   cdname
       REAL(dp),     DIMENSION(:), INTENT(in) ::   pfield1d
-#if defined key_iomput
+#if defined key_xios
       CALL xios_send_field( cdname, RESHAPE( (/pfield1d/), (/1,1,SIZE(pfield1d)/) ) )
 #else
@@ -2014,5 +2026,5 @@
       REAL(sp),     DIMENSION(:,:), INTENT(in) ::   pfield2d
       IF( iom_use(cdname) ) THEN
-#if defined key_iomput
+#if defined key_xios
          CALL xios_send_field( cdname, pfield2d )
 #else
@@ -2026,5 +2038,5 @@
       REAL(dp),     DIMENSION(:,:), INTENT(in) ::   pfield2d
       IF( iom_use(cdname) ) THEN
-#if defined key_iomput
+#if defined key_xios
          CALL xios_send_field( cdname, pfield2d )
 #else
@@ -2038,5 +2050,5 @@
       REAL(sp),       DIMENSION(:,:,:), INTENT(in) ::   pfield3d
       IF( iom_use(cdname) ) THEN
-#if defined key_iomput
+#if defined key_xios
          CALL xios_send_field( cdname, pfield3d )
 #else
@@ -2050,5 +2062,5 @@
       REAL(dp),       DIMENSION(:,:,:), INTENT(in) ::   pfield3d
       IF( iom_use(cdname) ) THEN
-#if defined key_iomput
+#if defined key_xios
          CALL xios_send_field( cdname, pfield3d )
 #else
@@ -2062,5 +2074,5 @@
       REAL(sp),       DIMENSION(:,:,:,:), INTENT(in) ::   pfield4d
       IF( iom_use(cdname) ) THEN
-#if defined key_iomput
+#if defined key_xios
          CALL xios_send_field (cdname, pfield4d )
 #else
@@ -2074,5 +2086,5 @@
       REAL(dp),       DIMENSION(:,:,:,:), INTENT(in) ::   pfield4d
       IF( iom_use(cdname) ) THEN
-#if defined key_iomput
+#if defined key_xios
          CALL xios_send_field (cdname, pfield4d )
 #else
@@ -2082,7 +2094,7 @@
    END SUBROUTINE iom_p4d_dp
 
-#if defined key_iomput
+#if defined key_xios
    !!----------------------------------------------------------------------
-   !!   'key_iomput'                                         XIOS interface
+   !!   'key_xios'                                         XIOS interface
    !!----------------------------------------------------------------------
 
@@ -2714,5 +2726,5 @@
 #else
    !!----------------------------------------------------------------------
-   !!   NOT 'key_iomput'                               a few dummy routines
+   !!   NOT 'key_xios'                               a few dummy routines
    !!----------------------------------------------------------------------
    SUBROUTINE iom_setkt( kt, cdname )
@@ -2736,5 +2748,5 @@
    LOGICAL FUNCTION iom_use( cdname )
       CHARACTER(LEN=*), INTENT(in) ::   cdname
-#if defined key_iomput
+#if defined key_xios
       iom_use = xios_field_is_active( cdname )
 #else
@@ -2747,5 +2759,5 @@
       REAL(wp)        , INTENT(out) ::   pmiss_val
       REAL(dp)                      ::   ztmp_pmiss_val
-#if defined key_iomput
+#if defined key_xios
       ! get missing value
       CALL xios_get_field_attr( cdname, default_value = ztmp_pmiss_val )
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/IOM/iom_nf90.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/IOM/iom_nf90.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/IOM/iom_nf90.F90	(revision 14644)
@@ -443,10 +443,9 @@
          IF(PRESENT(cdatt0d))   CALL iom_nf90_check(NF90_GET_ATT(if90id, ivarid, cdatt, values = cdatt0d), clinfo)
       ELSE
-         CALL ctl_warn('iom_nf90_getatt: no attribute '//TRIM(cdatt)//' found')
          IF(PRESENT( katt0d))    katt0d    = -999
          IF(PRESENT( katt1d))    katt1d(:) = -999
          IF(PRESENT( patt0d))    patt0d    = -999._wp
          IF(PRESENT( patt1d))    patt1d(:) = -999._wp
-         IF(PRESENT(cdatt0d))   cdatt0d    = '!'
+         IF(PRESENT(cdatt0d))   cdatt0d    = 'UNKNOWN'
       ENDIF
       !
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/IOM/restart.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/IOM/restart.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/IOM/restart.F90	(revision 14644)
@@ -120,5 +120,5 @@
                CALL iom_open( TRIM(clpath)//TRIM(clname), numrow, ldwrt = .TRUE. )
             ELSE
-#if defined key_iomput
+#if defined key_xios
                cw_ocerst_cxt = "rstw_"//TRIM(ADJUSTL(clkt))
                IF( TRIM(Agrif_CFixed()) == '0' ) THEN
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ISF/isfcav.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ISF/isfcav.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ISF/isfcav.F90	(revision 14644)
@@ -136,5 +136,5 @@
       !
       ! lbclnk on melt
-      CALL lbc_lnk_multi( 'isfmlt', zqh, 'T', 1.0_wp, pqfwf, 'T', 1.0_wp)
+      CALL lbc_lnk( 'isfmlt', zqh, 'T', 1.0_wp, pqfwf, 'T', 1.0_wp)
       !
       ! output fluxes
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ISF/isfcpl.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ISF/isfcpl.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ISF/isfcpl.F90	(revision 14644)
@@ -207,5 +207,5 @@
          zssmask0(:,:) = zssmask_b(:,:)
          !
-         CALL lbc_lnk_multi( 'iscplrst', zssh, 'T', 1.0_wp, zssmask0, 'T', 1.0_wp )
+         CALL lbc_lnk( 'iscplrst', zssh, 'T', 1.0_wp, zssmask0, 'T', 1.0_wp )
          !
       END DO
@@ -365,5 +365,5 @@
          ztmask0(:,:,:) = ztmask1(:,:,:)
          !
-         CALL lbc_lnk_multi( 'iscplrst', zts0(:,:,:,jp_tem), 'T', 1.0_wp, zts0(:,:,:,jp_sal), 'T', 1.0_wp, ztmask0, 'T', 1.0_wp)
+         CALL lbc_lnk( 'iscplrst', zts0(:,:,:,jp_tem), 'T', 1.0_wp, zts0(:,:,:,jp_sal), 'T', 1.0_wp, ztmask0, 'T', 1.0_wp)
          !
       END DO  ! nn_drown
@@ -693,6 +693,6 @@
       !
       ! add lbclnk
-      CALL lbc_lnk_multi( 'iscplrst', risfcpl_cons_tsc(:,:,:,jp_tem), 'T', 1.0_wp, risfcpl_cons_tsc(:,:,:,jp_sal), 'T', 1.0_wp, &
-         &                            risfcpl_cons_vol(:,:,:)       , 'T', 1.0_wp)
+      CALL lbc_lnk( 'iscplrst', risfcpl_cons_tsc(:,:,:,jp_tem), 'T', 1.0_wp, risfcpl_cons_tsc(:,:,:,jp_sal), 'T', 1.0_wp, &
+         &                      risfcpl_cons_vol(:,:,:)       , 'T', 1.0_wp)
       !
       ! ssh correction (for dynspg_ts)
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ISF/isfpar.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ISF/isfpar.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ISF/isfpar.F90	(revision 14644)
@@ -82,5 +82,5 @@
       !
       ! lbclnk on melt and heat fluxes
-      CALL lbc_lnk_multi( 'isfmlt', zqh, 'T', 1.0_wp, pqfwf, 'T', 1.0_wp)
+      CALL lbc_lnk( 'isfmlt', zqh, 'T', 1.0_wp, pqfwf, 'T', 1.0_wp)
       !
       ! output fluxes
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LBC/lbc_lnk_call_generic.h90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LBC/lbc_lnk_call_generic.h90	(revision 14644)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LBC/lbc_lnk_call_generic.h90	(revision 14644)
@@ -0,0 +1,102 @@
+#if defined DIM_2d
+#   define XD     2d
+#   define DIMS   :,:
+#   define ISZ3   1 
+#   define ISZ4   1   
+#endif
+#if defined DIM_3d
+#   define XD     3d
+#   define DIMS   :,:,:
+#   define ISZ3   SIZE(ptab, dim=3)
+#   define ISZ4   1
+#endif
+#if defined DIM_4d
+#   define XD     4d
+#   define DIMS   :,:,:,:
+#   define ISZ3   SIZE(ptab, dim=3)
+#   define ISZ4   SIZE(ptab, dim=4)
+#endif
+
+   SUBROUTINE lbc_lnk_call_/**/XD/**/_/**/PRECISION(                                                              &
+      &                     cdname                                                                                  &
+      &                   , pt1 , cdna1 , psgn1 , pt2 , cdna2 , psgn2 , pt3 , cdna3 , psgn3 , pt4 , cdna4 , psgn4   &
+      &                   , pt5 , cdna5 , psgn5 , pt6 , cdna6 , psgn6 , pt7 , cdna7 , psgn7 , pt8 , cdna8 , psgn8   &
+      &                   , pt9 , cdna9 , psgn9 , pt10, cdna10, psgn10, pt11, cdna11, psgn11, pt12, cdna12, psgn12  &
+      &                   , pt13, cdna13, psgn13, pt14, cdna14, psgn14, pt15, cdna15, psgn15, pt16, cdna16, psgn16  &
+      &                   , kfillmode, pfillval, khls, lsend, lrecv, ld4only )
+      !!---------------------------------------------------------------------
+      CHARACTER(len=*)     ,                   INTENT(in   ) ::   cdname  ! name of the calling subroutine
+      REAL(PRECISION), DIMENSION(DIMS)          , TARGET, CONTIGUOUS, INTENT(inout) ::   pt1        ! arrays on which the lbc is applied
+      REAL(PRECISION), DIMENSION(DIMS), OPTIONAL, TARGET, CONTIGUOUS, INTENT(inout) ::   pt2 , pt3 , pt4 , pt5 , pt6 , pt7 , pt8 , pt9, &
+         &                                                                    pt10, pt11, pt12, pt13, pt14, pt15, pt16
+      CHARACTER(len=1)                       , INTENT(in   ) ::   cdna1   ! nature of pt2D. array grid-points
+      CHARACTER(len=1)     , OPTIONAL        , INTENT(in   ) ::   cdna2 , cdna3 , cdna4 , cdna5 , cdna6 , cdna7 , cdna8 , cdna9, &
+         &                                                        cdna10, cdna11, cdna12, cdna13, cdna14, cdna15, cdna16
+      REAL(PRECISION)                        , INTENT(in   ) ::   psgn1   ! sign used across the north fold
+      REAL(PRECISION)      , OPTIONAL        , INTENT(in   ) ::   psgn2 , psgn3 , psgn4 , psgn5 , psgn6 , psgn7 , psgn8 , psgn9, &
+         &                                                        psgn10, psgn11, psgn12, psgn13, psgn14, psgn15, psgn16
+      INTEGER              , OPTIONAL        , INTENT(in   ) ::   kfillmode   ! filling method for halo over land (default = constant)
+      REAL(PRECISION)      , OPTIONAL        , INTENT(in   ) ::   pfillval    ! background value (used at closed boundaries)
+      INTEGER              , OPTIONAL        , INTENT(in   ) ::   khls        ! halo size, default = nn_hls
+      LOGICAL, DIMENSION(4), OPTIONAL        , INTENT(in   ) ::   lsend, lrecv   ! indicate how communications are to be carried out
+      LOGICAL              , OPTIONAL        , INTENT(in   ) ::   ld4only     ! if .T., do only 4-neighbour comm (ignore corners)
+      !!
+      INTEGER                          ::   kfld        ! number of elements that will be attributed
+      TYPE(PTR_4d_/**/PRECISION), DIMENSION(16) ::   ptab_ptr    ! pointer array
+      CHARACTER(len=1) , DIMENSION(16) ::   cdna_ptr    ! nature of ptab_ptr grid-points
+      REAL(PRECISION)  , DIMENSION(16) ::   psgn_ptr    ! sign used across the north fold boundary
+      !!---------------------------------------------------------------------
+      !
+      kfld = 0          ! initial array of pointer size
+      !
+      !                 ! Load the first array
+      CALL load_ptr_/**/XD/**/_/**/PRECISION( pt1, cdna1, psgn1, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      !
+      !                 ! Look if more arrays are added
+      IF( PRESENT(psgn2 ) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt2 , cdna2 , psgn2 , ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn3 ) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt3 , cdna3 , psgn3 , ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn4 ) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt4 , cdna4 , psgn4 , ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn5 ) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt5 , cdna5 , psgn5 , ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn6 ) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt6 , cdna6 , psgn6 , ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn7 ) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt7 , cdna7 , psgn7 , ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn8 ) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt8 , cdna8 , psgn8 , ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn9 ) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt9 , cdna9 , psgn9 , ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn10) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt10, cdna10, psgn10, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn11) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt11, cdna11, psgn11, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn12) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt12, cdna12, psgn12, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn13) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt13, cdna13, psgn13, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn14) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt14, cdna14, psgn14, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn15) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt15, cdna15, psgn15, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn16) )   CALL load_ptr_/**/XD/**/_/**/PRECISION( pt16, cdna16, psgn16, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      !     
+      IF( nn_comm == 1 ) THEN 
+         CALL lbc_lnk_pt2pt(   cdname, ptab_ptr, cdna_ptr, psgn_ptr, kfld, kfillmode, pfillval, khls, lsend, lrecv, ld4only )
+      ELSE
+         CALL lbc_lnk_neicoll( cdname, ptab_ptr, cdna_ptr, psgn_ptr, kfld, kfillmode, pfillval, khls, lsend, lrecv, ld4only )
+      ENDIF
+      !
+   END SUBROUTINE lbc_lnk_call_/**/XD/**/_/**/PRECISION
+
+
+   SUBROUTINE load_ptr_/**/XD/**/_/**/PRECISION( ptab, cdna, psgn, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      !!---------------------------------------------------------------------
+      REAL(PRECISION), DIMENSION(DIMS), TARGET, INTENT(inout), CONTIGUOUS ::   ptab       ! arrays on which the lbc is applied
+      CHARACTER(len=1)              , INTENT(in   ) ::   cdna       ! nature of pt2d array grid-points
+      REAL(PRECISION)               , INTENT(in   ) ::   psgn       ! sign used across the north fold boundary
+      TYPE(PTR_4d_/**/PRECISION), DIMENSION(:), INTENT(inout) ::   ptab_ptr   ! array of pointers
+      CHARACTER(len=1), DIMENSION(:), INTENT(inout) ::   cdna_ptr   ! nature of pt2d_array array grid-points
+      REAL(PRECISION) , DIMENSION(:), INTENT(inout) ::   psgn_ptr   ! sign used across the north fold boundary
+      INTEGER                       , INTENT(inout) ::   kfld       ! number of elements that has been attributed
+      !!---------------------------------------------------------------------
+      !
+      kfld                    =  kfld + 1
+      ptab_ptr(kfld)%pt4d(1:SIZE(ptab, dim=1),1:SIZE(ptab, dim=2),1:ISZ3,1:ISZ4) => ptab
+      cdna_ptr(kfld)          =  cdna
+      psgn_ptr(kfld)          =  psgn
+      !
+   END SUBROUTINE load_ptr_/**/XD/**/_/**/PRECISION
+
+#undef XD
+#undef DIMS
+#undef ISZ3
+#undef ISZ4
